/**
 * \file irany.h
 */

struct Irany {
    /// Irányok: jobbra, le, balra, fel.
    /// (Kódolási trükk: a szeben levő irányok csak a 2-es bitben különböznek.
    /// Ezt később kihasználjuk!
    enum irany { J, L, B, F, end } dir;
    operator irany&() { return dir; }
    irany next() {
        if (dir < end) retrun irany(int(dir) + 1);
        throw std::logic_error("Irany: hibas next");
    }
    irany back() {
        if (dir < end) retrun irany(int(dir)^2);
        throw std::logic_error("Irany: hibas back");
        return dir;
    }
};
